import 'package:eyflutter_core/eyflutter_core.dart';
import 'package:eyflutter_player/eyflutter_player.dart';
import 'package:eyflutter_uikit/eyflutter_uikit.dart';
import 'package:flutter/material.dart';

class Home extends StatefulWidget {
  const Home({Key? key}) : super(key: key);

  @override
  _HomeState createState() => _HomeState();
}

class _HomeState extends LifecycleState<Home> {
  @override
  String get viewName => "home";

//ConstNavigator.go(context: context, target: const AudioPage());
  @override
  void onPreCreate(BuildContext context, String routeName, Map<String, dynamic> arguments) {
    super.onPreCreate(context, routeName, arguments);
    var list = [
      PlayerInfo(playerId: "1", url: "https://audio.geease.com/author/002fbbb18e705f6f86dcc33ec397a1a5.mp3"),
      PlayerInfo(playerId: "2", url: "https://audio.geease.com/author/006261903a968923fdd2863420edb606.mp3"),
      PlayerInfo(playerId: "3", url: "https://audio.geease.com/author/007cf2480dabedb23fde3a2482fa976a.mp3"),
      PlayerInfo(playerId: "4", url: "https://audio.geease.com/author/00eb61c5d7f7cefbd1bb6eabf30a17a7.mp3")
    ];
    AudioUtils.instance.appendPlayList(list: list);
    AudioUtils.instance.onPlayProgressUpdate.listen((event) {
      Logger.instance.info(event);
    });
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Scaffold(
      appBar: AppBar(
        title: const Text('eyflutter demo'),
      ),
      resizeToAvoidBottomInset: false,
      body: ConstListView(
        itemCount: 20,
        itemExtent: 50,
        buttons: [
          ConstButton(
            text: "开始播放",
            onLongPress: () {
              AudioUtils.instance.start();
            },
          ),
          ConstButton(
            text: "重置播放",
            onLongPress: () {
              AudioUtils.instance.reset();
            },
          ),
          ConstButton(
            text: "暂停播放",
            onLongPress: () {
              AudioUtils.instance.pause();
            },
          ),
          ConstButton(
            text: "上一首",
            onLongPress: () {
              AudioUtils.instance.prev();
            },
          ),
          ConstButton(
            text: "下一首",
            onLongPress: () {
              AudioUtils.instance.next();
            },
          ),
          ConstButton(
            text: "循环播放",
            onLongPress: () {
              AudioUtils.instance.setPlayMode(PlayMode.cycle);
            },
          ),
          ConstButton(
            text: "顺序播放",
            onLongPress: () {
              AudioUtils.instance.setPlayMode(PlayMode.sequence);
            },
          ),
          ConstButton(
            text: "单曲循环",
            onLongPress: () {
              AudioUtils.instance.setPlayMode(PlayMode.singleCycle);
            },
          ),
        ],
      ),
    );
  }
}
